# std::reverse

From cppreference.com
< cpp‎ | algorithm

Defined in header `<algorithm>` |  |
| (1) |
template< class BidirIt > void reverse( BidirIt first, BidirIt last ); |  | (until C++20)
template< class BidirIt > constexpr void reverse( BidirIt first, BidirIt last ); |  | (since C++20)
template< class ExecutionPolicy, class BidirIt > void reverse( ExecutionPolicy&& policy, BidirIt first, BidirIt last ); | (2) | (since C++17)

1) Reverses the order of the elements in the range `[first, last)`
Behaves as if applying std::iter_swap to every pair of iterators `first+i, (last-i) - 1` for each non-negative `i < (last-first)/2`
2) Same as (1), but executed according to `policy`. This overload does not participate in overload resolution unless std::is_execution_policy_v < std::decay_t <ExecutionPolicy>> is true

### Parameters

first, last | - | the range of elements to reverse
policy | - | the execution policy to use. See execution policy for details.
Type requirements
- `BidirIt` must meet the requirements of ValueSwappable and LegacyBidirectionalIterator.

### Return value

(none)

### Exceptions

The overload with a template parameter named `ExecutionPolicy` reports errors as follows:

- If execution of a function invoked as part of the algorithm throws an exception and `ExecutionPolicy` is one of the standard policies, std::terminate is called. For any other `ExecutionPolicy`, the behavior is implementation-defined.
- If the algorithm fails to allocate memory, std::bad_alloc is thrown.

### Possible implementation

See also the implementations in libstdc++ and libc++.

    template<class BidirIt>
    void reverse(BidirIt first, BidirIt last)
    {
        while ((first != last) && (first != --last)) {
            std::iter_swap(first++, last);
        }
    }

### Complexity

Exactly `(last - first)/2` swaps.

### Example

Run this code

    #include <vector>
    #include <iostream>
    #include <iterator>
    #include <algorithm>

    int main()
    {
        std::vector<int> v{1,2,3};
        std::reverse(std::begin(v), std::end(v));
        for(auto e : v) std::cout << e;
        std::cout << '\n';

        int a[] = {4, 5, 6, 7};
        std::reverse(std::begin(a), std::end(a));
        for(auto e : a) std::cout << e;
    }

Output:

    321
    7654

### See also

reverse_copy | creates a copy of a range that is reversed (function template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/algorithm/reverse&oldid=110868"